<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Remote control app</title>
    <style>
        #app-container {
            border: 1px solid black;
            border-radius: 5px;
            width: fit-content;
            padding: 22px;
            margin-bottom: 12px;
        }

        .button-container {
            width: 100%;
            text-align: center;
        }

        #range-velocity {
            margin-bottom: 20px;
            width: 100%;
        }

        #connected-text {
            text-align: center;
            width: 100%;
            margin: 4px;
            display: none;
        }

        #error-text {
            text-align: center;
            width: 100%;
            margin: 4px;
            color: red;
            display: none;
        }

        #disconnect-button {
            display: none;
        }
    </style>
</head>

<body>
    <h3>Remote control app</h3>
    <div id="app-container">
        <input id="key-input" type="text" placeholder="Connection Key">
        <p id="connected-text">Connected</p>
        <p id="error-text">Failed to connect</p>
        <br>
        <br>
        <div class="button-container">
            <button id="connect-button">Connect</button>
            <button id="disconnect-button">Disconnect</button>
        </div>
        <br>
        <br>
        <input id="range-velocity" type="range" value="0" />
        <div class="button-container">
            <button id="start-button">Start</button>
            <button id="stop-button">Stop</button>
        </div>
    </div>
</body>
<script src="https://unpkg.com/@ohdoki/handy-sdk@2.3.2"></script>
<script>
    const startButton = document.getElementById("start-button");
    const stopButton = document.getElementById("stop-button");
    const connectButton = document.getElementById("connect-button");
    const disconnectButton = document.getElementById("disconnect-button");
    const rangeVelocity = document.getElementById("range-velocity");
    const keyInput = document.getElementById("key-input");
    const connectedText = document.getElementById("connected-text");
    const errorText = document.getElementById("error-text");
    const handy = Handy.init();

    async function checkForKey() {
        const key = await handy.getStoredKey();
        if (key) {
            keyInput.value = key;
        }
    }
    checkForKey();

    startButton.addEventListener("click", (evt) => {
        console.log("Start button clicked");
        handy.hampPlay();
    });
    stopButton.addEventListener("click", (evt) => {
        console.log('Stop button clicked');
        handy.hampStop();
    });
    rangeVelocity.addEventListener("input", (evt) => {
        console.log('input');
        const velocity = rangeVelocity.value;
        handy.setHampVelocity(velocity);
    });
    connectButton.addEventListener("click", (evt) => {
        console.log("connect button clicked");
        const connectionKey = keyInput.value;
        handy.connect(connectionKey).then((connected) => {
            if (connected === 1) {
                keyInput.style.display = "none";
                connectButton.style.display = "none";
                connectedText.style.display = "block";
                disconnectButton.style.display = "inline";
            } else {
                errorText.style.display = "block";
                setTimeout(() => {
                    errorText.style.display = "none";
                }, 1000);
            }
        });
    });
    disconnectButton.addEventListener("click", (evt) => {
        console.log("disconnect button clicked");
        handy.disconnect();
        keyInput.style.display = "block";
        connectButton.style.display = "inline";
        connectedText.style.display = "none";
        disconnectButton.style.display = "none";
    });

</script>

</html>